
#******************************************************************#
# Licensed Materials - Property of IBM                             #
# (C) Copyright IBM Corp. 2015  All Rights Reserved                #
# US Government Users Restricted Rights - Use, duplication or      #
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.#
#******************************************************************#
#                                                                  #
# Purpose of this script is to telnet to a VIOS partition, run the #
# SNAP command, and bring back data to this PC to be uploaded to   #
# IBM                                                              #
#******************************************************************#
# @01 10/24/2015  NKN  Initial creation                            #
#******************************************************************#

from sys import argv     # Passing arguments
from ftplib import FTP
import os

script, host, user, password = argv
#-------------
# Variables 
#-------------
port = 21
timeout = 10

rmtfile = "/home/padmin/snap.pax.Z"
lclfile_path = "/tmp/daggity_file"
lclfile = "daggity_file"
tmpfile = "/tmp/tmp_snap.pax.Z"

os.system("rm -rf %s" % tmpfile)
infile = open(tmpfile, "wb")
size = 0

#------------------------------------------
# This is where we write to the local file 
# and output the transfer size 
#------------------------------------------
def inputfile(data):
   global size
   size_char = " "
   infile.write(data)
   size = os.path.getsize(tmpfile)        
   print "%d bytes\r" % size,             # the \r and comma a the end causes the line to be re-written
   
#------------------------------------------------------
# Create an FTP object so that we can use the methods 
#------------------------------------------------------
ftp = FTP()

#--------------------------------------------------
# Now since we created the object, we can use the 
# connect method 
#--------------------------------------------------
ftp_good = 1
print "Connecting to %s" % host
try:
   ftp.connect(host, port, timeout)
except:
   print "FTP failed..."
   ftp_good = 0

#----------------------------------------
# FTP is good, so let's do the transfer
#----------------------------------------
while ftp_good == 1:
   print "Signing on..."
   retrieve_file = 1
   try:
      ftp.login(user, password)
   except:
      retrieve_file = 0
      print "Error w/ login..."
      break
   print "Retrieving snap file..."
   try:
      data = ftp.retrbinary("RETR %s" % rmtfile, inputfile)
   except:
      retrieve_file = 0
      print "Data transfer error..."
      break 
   print "\n"
   print data
   break

#---------------------------------------------------
# If the file was transferred successfully, let's
# move this temp file to /tmp/qmgtools_snap.pax.Z
#---------------------------------------------------
if retrieve_file == 1:
   lclfile_path = "/tmp/" + host + "_snap.pax.Z"
   lclfile = host + "_snap.pax.Z"
   os.system("rm -rf %s" % lclfile_path)
   os.system("mv %s %s" % (tmpfile, lclfile_path))
   print "File saved to %s" % lclfile_path
   os.system("rm -rf ./data_area")
   os.system("echo %s > ./data_area" % lclfile)

ftp.close()



