
#******************************************************************#
# Licensed Materials - Property of IBM                             #
# (C) Copyright IBM Corp. 2015  All Rights Reserved                #
# US Government Users Restricted Rights - Use, duplication or      #
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.#
#******************************************************************#
#                                                                  #
# Purpose of this script is to telnet to a VIOS partition, run the #
# SNAP command, and bring back data to this PC to be uploaded to   #
# IBM                                                              #
#******************************************************************#
# @01 10/24/2015  NKN  Initial creation                            #
#******************************************************************#

import getpass
import sys
import telnetlib
import os
import readline
import subprocess        # So that we can call shell commands
import shlex             # So that it's easier to break down shell commands

#-----------------------------
# Find login string function
#-----------------------------
def find_login(sck):
   timer = 0
   result = 0
   while timer < 31:
      data = sck.read_until("$%$",1)
      print data
      data = data.upper()
      found = data.find("LOGIN")
      if found > 0:
         result = 1
         break
      timer = timer + 1
   return result

#-------------------------------
# Find password string function
#-------------------------------
def find_pass(sck):
   timer = 0
   result = 0
   while timer < 31:
      data = sck.read_until("$%$",1)
      print data
      data = data.upper()
      found = data.find("PASS")
      if found > 0:
         result = 1
         break
      timer = timer + 1
   return result

#----------------------
# Read data off line 
#----------------------
def read_line(sck):
   tmpdata = " "
   data = sck.read_until("$%$",1)
   size = len(data)
   while size > 0:
      tmpdata = tmpdata + data 
      data = sck.read_until("$%$",1)
      size = len(data)    
      if size == 0:
         data = tmpdata
         break
   return data 

      
#------------
# Variables
#------------
port = 23
timeout = 10

#------------------------------
# Get some input from the user
#------------------------------
os.system("clear")
print "*-------------------------------------------------*"
print "* Collect SNAP data from VIOS using these steps : *"
print "*                                                 *" 
print "* - Telnet to VIOS using padmin user ID           *"
print "* - Run the snap command                          *"
print "* - FTP the snap file back to local host          *"
print "--------------------------------------------------*"
while 0==0:
   host = raw_input("Remote system : ")
   if host != "":
      break
while 0==0:
   print "Enter password for padmin"
   password = getpass.getpass()
   if password != "":
      break
user = "padmin"

telnet_fail = 0

#-----------------------
# Connect to the remote
#-----------------------
print "Connecting to remote : %s" % host
try:
   socket = telnetlib.Telnet(host, port, timeout)
except:
   print "Error connecting to remote..."
   telnet_fail = 1

#-------------------------------------
# If we passed the telnet, lets log on
#-------------------------------------
while telnet_fail == 0:
   find_prompt = 1
   good = find_login(socket)
   if good > 0:
      socket.write(user + "\n")
      good = find_pass(socket)
      if good > 0: 
         socket.write(password + "\n")
         break         
      else:
         find_prompt = 0
         print "Failed to find password prompt..."
         break  
   else:
      find_prompt = 0
      print "Failed to find login prompt..."
      break
   break

#---------------------------------------
# We must have passed the signon screen 
#---------------------------------------
while find_prompt == 1:

   #---------------------------------
   # Need to find the command prompt
   #---------------------------------
   data = read_line(socket)
   print data 
   words = data.split()  
   tmpdata = data.upper()
   found = tmpdata.find("LAST LOGIN")
   if found > 0:
      size = len(words)
      size = size - 1
      cmdprompt = words[size]
      get_snap = 1
      break
   else:
      get_snap = 0
      print "Unable to find command prompt"
      break
   
#---------------------------------------------
# Grab the snap - if command prompt was found 
#---------------------------------------------
if get_snap == 1:
   print "Deleting old snap file"
   socket.write("rm -rf /home/pdadmin/snap.pax.Z\n")
   found = 0
   while True:
      data = read_line(socket)
      tmpdata = data.upper()
      found = tmpdata.find(cmdprompt)
      if found > 0:
         break

   print "Running snap command..."
   # socket.write("rm -rf /home/pdadmin/snap.pax.Z\n")
   socket.write("snap\n")
   while get_snap == 1:
      data = read_line(socket)
      size = len(data)
      if size > 0:
         print data
      tmpdata = data.upper()   
      found = tmpdata.find(cmdprompt)
      if found > 0:
         break
    
#-------------------------
# Close the telnet socket
#-------------------------
socket.close()
      
#-------------------------------------
# Now let's try to FTP the file back 
#-------------------------------------
#subprocess.call(["python", "./vios_ftp.pyc", host, user, password])
subprocess.call(["python", "./vios_ftp.py", host, user, password])
   
